<?php
	error_reporting(E_ERROR);
	
	$input = file_get_contents("php://stdin");
	$variables = parse_variables($input);
	usort($variables, function ($a, $b) {
		return strcmp($a["name"], $b["name"]);
	});
	echo json_encode($variables);
	
	function parse_variables($input) {
		$variables = array();
		while (preg_match('/^(.*?) = /m', $input, $matches, PREG_OFFSET_CAPTURE)) {
			$name = $matches[1][0];
			$loc = $matches[0][1]+strlen($matches[0][0]);
			$value = parse_value($input, $loc, $cutloc);
			if (gettype($value) == 'string' && strlen($value) > 1500) {
				$value = substr($value, 0, 1500)." [...]";
			}
			array_push($variables, array(
				"name" => $name,
				"value" => $value
			));
			$input = substr($input, $cutloc);
		}
		return $variables;
	}
	
	function parse_value($input, $loc, &$cutloc) {
		if ($loc == strlen($input)) return "";
		if ($input[$loc] == "'" || $input[$loc] == '"') {
			$escapeCount = 0;
			$i = $loc+1;
			for (; $i < strlen($input); $i++) {
				if ($input[$i] == $input[$loc] && $escapeCount % 2 == 0) {
					break;
				}
				if ($input[$i] == "\\") {
					$escapeCount++;
				} else {
					$escapeCount = 0;
				}
			}
			$cutloc = $i+1;
			return substr($input, $loc, $i-$loc+1);
		} else if ($input[$loc] == "(") {
			$i = $loc+1;
			$array = array();
			$linestart = $i;
			$whitespace = 0;
			$key = false;
			for (; $i < strlen($input); $i++) {
				if ($input[$i] == "\r" || $input[$i] == "\n") {
					if (!($key === false)) {
						array_push($array, array("name" => $key, "value" => ""));
						$key = false;
					}
					$linestart = $i+1;
				} else if ($input[$i] == ")") {
					if (!($key === false)) {
						array_push($array, array("name" => $key, "value" => ""));
					}
					break;
				}
				if ($input[$i] == " " || $input[$i] == "\t") {
					$whitespace++;
				} else {
					if ($i == $linestart+$whitespace) {
						if ($input[$i] == "'" || $input[$i] == '"') {
							$key = parse_value($input, $i, $cutloc);
							$i = $cutloc-1;
							if (substr($input, $i+1, 4) == " => ") {
								$i += 4;
							}
						} else {
							sscanf(substr($input, $i), "%i", $key);
							$key = "$key";
							$i += strlen($key);
						}
					} else if (!($key === false)) {
						$value = parse_value($input, $i, $cutloc);
						$i = $cutloc-1;
						array_push($array, array("name" => $key, "value" => $value));
						$key = false;
					}
					$whitespace = 0;
				}
			}
			$cutloc = $i+1;
			return $array;
		} else {
			$line_end = strlen($input);
			$i = $loc;
			for (; $i < $line_end; $i++) {
				if ($input[$i] == "\r" || $input[$i] == "\n") {
					break;
				}
			}
			$cutloc = $i;
			return substr($input, $loc, $i-$loc);
		}
	}
?>